#include <stdio.h>
#include <math.h>
#include <avs/flow.h>
#include <avs/avs_data.h>
#include <avs/field.h>
#include <time.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/timeb.h>

interface()
{
	int out_port;		/* temporary to hold the port number */
	int parm;		/* temporary to hold the parm number */

	/* Set the module name and type */
	AVSset_module_name("Input_interface_SUN", MODULE_DATA);

	/* There are no input ports for this module */

        /* Create output ports for the result */
        out_port = AVScreate_output_port("Field Output", "field 1D scalar uniform float");
	

	/* Add parameter:  */
	parm = AVSadd_parameter("I","integer",10, 1, 10); 
	parm = AVSadd_parameter("J","integer",10, 1, 10); 
	parm = AVSadd_float_parameter("HA", 0.5, 0.1, 10.0);
	parm = AVSadd_parameter("M","integer",128, 1, 256); 
	parm = AVSadd_parameter("N","integer",128, 1, 256); 
	parm = AVSadd_float_parameter("FAI", 0.6, 0.0, 1.57);
	parm = AVSadd_float_parameter("HD", 0.1, 0.1, 10.0);
	parm = AVSadd_parameter("Do it!", "boolean", 1, 0, 1);

	/* There is no compute function for this module */
}

#define Stockdata 7

main(argc,argv)
int	argc;
char	*argv[];
{
  
  int sleep = 1;
   int i,j,m,n;
   float  *ha, *fai, *hd;
   AVSfield_float *output, *input;  
   int dims[1];

   /* coroutine initilization */
   AVScorout_init(argc,argv,interface);
   AVScorout_set_sync(0);

    /* Allocate space for stock data */
   dims[0] = Stockdata;
   input = (AVSfield_float *)AVSdata_alloc
     ("field 1D scalar uniform float",dims);

   while (1) {

     do {
       AVScorout_wait();
       AVScorout_input(&i,&j,&ha,&m,&n,&fai,&hd,&sleep);
     } while (sleep);
     input->data[0] = i; input->data[1] = j;
     input->data[2] = *ha;
     input->data[3] = m; input->data[4] = n;
     input->data[5] = *fai; input->data[6] = *hd;
       
     output = input;

     AVScorout_exec(); /* syncronization */
     AVScorout_output(output);
     fprintf(stderr, "Interface  Done \n");
     AVSmodify_parameter("Do it!",AVS_VALUE, 1, 0, 1);
     sleep = 1;

   }
   fprintf(stderr, "\n!!!!!!!! Done !!!!!!!!\n");
/*   AVSfield_free(input); */
   
 }
